C rewritten ALL subroutine S. Parker 22/6/95
C To calculate parabolic rate constant ALPHA3 for 3-D growth
C
        SUBROUTINE ALL3(XGAG,XBAR,XAGA,DIFF,ALPHA3)
        IMPLICIT NONE                          
        DOUBLE PRECISION OMEGA,DUM3,DER3,DX3,ALPHA3,GES3,DIFF,
     &  XGAG,XAGA,XBAR,BISECT,FLAG,OLDGES3,DERF
        INTEGER I3
C GES3 is a guess value for solution to H1 equation (see Prog Mat Science 1985)
        GES3=0.51466
        I3=0
C OMEGA is the supersaturation of carbon
        OMEGA=(XGAG-XBAR)/(XGAG-XAGA)
        BISECT=1.0
        FLAG=0

10      DO 9 I3=1, 30
C       DUM3 is equation which equals zero at correct GES3
                DUM3=2.0d+00*GES3*GES3*(1.0d+00-(GES3*DSQRT(3.14159d+00)
     &	        *(1.0d+00-DERF(GES3))*DEXP(GES3*GES3)))-OMEGA
C       DER3 is the derivative of DUM3
                DER3=4.0d+00*GES3*(1.0d+00+(GES3*GES3))-(2.0d+00*DSQRT(3.14159
     &	        d+00)*GES3*GES3*DEXP(GES3*GES3)*(1.0d+00-DERF(GES3))*
     &	        (3.0d+00+2.0d+00*GES3*GES3))
C      DX3 is the stepsize for refining GES3
                DX3=BISECT*(DUM3/DER3)
                OLDGES3=GES3
C      Use Newton iteration method to find root (GES3)
                GES3=GES3-DX3
C      Endtest is if step for next iteration very small
                IF (DABS(DX3) .LT. 1.0D-6) GOTO 99
9       CONTINUE
        IF (FLAG .EQ. 0) THEN
C If no convergence after 30 iterations, halve step size and restart
                WRITE(*,*) "SMALLER DX3 USED"
                BISECT=0.5
                GES3=0.51466
                FLAG=1
C               I3=0
                GOTO 10
        ENDIF
C       PAUSE 'NO CONVERGENCE'
99      ALPHA3=GES3*2.0D+00*DSQRT(DIFF)

        RETURN
        END

